"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_root_siblings_1 = __importDefault(require("react-native-root-siblings"));
const react_native_1 = require("react-native");
const style_1 = __importDefault(require("./style"));
const Drawer_1 = __importDefault(require("../Drawer"));
const Colors_1 = __importDefault(require("../Colors"));
const Button_1 = __importDefault(require("../Button"));
const Icons_1 = __importDefault(require("../Icons"));
const reducer_1 = __importDefault(require("../Fn/reducer"));
const Fetch_1 = __importDefault(require("../Fetch"));
const getAuth_1 = __importDefault(require("../Fn/getAuth"));
let citySelectView = undefined;
const CitySelectView = ({ types = 'city', title = '配送至', currentData, onSumbit, }) => {
    const refDrawer = (0, react_1.useRef)();
    const initState = {
        cTab: 'prov',
        provList: [],
        cityList: [],
        areaList: [],
    };
    const [state, setState] = (0, reducer_1.default)(Object.assign({}, initState));
    const [area, setArea] = (0, react_1.useState)({
        prov: (currentData === null || currentData === void 0 ? void 0 : currentData.prov) || {},
        city: (currentData === null || currentData === void 0 ? void 0 : currentData.city) || {},
        area: (currentData === null || currentData === void 0 ? void 0 : currentData.area) || {},
    });
    (0, react_1.useLayoutEffect)(() => {
        initDatas();
    }, []);
    const initDatas = () => __awaiter(void 0, void 0, void 0, function* () {
        getDatas('prov', '0');
    });
    const getDatas = (type, id) => __awaiter(void 0, void 0, void 0, function* () {
        var _a, _b;
        const headers = yield (0, getAuth_1.default)();
        const raw = yield (0, Fetch_1.default)('position/province', {}, {
            method: 'GET',
            headers
        });
        const res = raw.records.map((v) => ({
            id: v.provCode,
            name: v.provName
        }));
        if (id === '0')
            (_a = refDrawer === null || refDrawer === void 0 ? void 0 : refDrawer.current) === null || _a === void 0 ? void 0 : _a.show();
        if (types === 'prov') {
            onType('prov', res);
        }
        else if (types === 'city') {
            if (type === 'prov') {
                onType('prov', res);
            }
            else {
                const idx = res.findIndex((v) => v.id === id);
                onType('city', (_b = res === null || res === void 0 ? void 0 : res[idx]) === null || _b === void 0 ? void 0 : _b.childrens);
            }
        }
        else {
        }
    });
    const onType = (type, res) => {
        switch (type) {
            case 'prov':
                setState({ provList: res || [] });
                break;
            case 'city':
                setState({ cityList: res || [] });
                break;
            case 'area':
                setState({ areaList: res || [] });
                break;
        }
    };
    const _onClose = () => {
        citySelectView === null || citySelectView === void 0 ? void 0 : citySelectView.destroy();
        citySelectView = undefined;
    };
    const _onSubmit = (res) => {
        var _a;
        onSumbit === null || onSumbit === void 0 ? void 0 : onSumbit(res);
        (_a = refDrawer === null || refDrawer === void 0 ? void 0 : refDrawer.current) === null || _a === void 0 ? void 0 : _a.hide();
    };
    const onTab = (type) => {
        setState({ cTab: type });
    };
    const onSelect = (item, k) => __awaiter(void 0, void 0, void 0, function* () {
        switch (state.cTab) {
            case 'prov':
                const optsProv = {
                    prov: item,
                };
                setArea(Object.assign({}, optsProv));
                if (types !== 'prov') {
                    yield getDatas('city', item.id);
                    setState({ cTab: 'city' });
                }
                else {
                    _onSubmit(Object.assign({}, optsProv));
                }
                break;
            case 'city':
                const optsCity = {
                    prov: area.prov,
                    city: item,
                };
                setArea(Object.assign({}, optsCity));
                if (types === 'area') {
                    yield getDatas('area', item.id);
                    setState({ cTab: 'area' });
                }
                else {
                    _onSubmit(Object.assign({}, optsCity));
                }
                break;
            case 'area':
                const optsArea = Object.assign(Object.assign({}, area), { area: item });
                setArea(Object.assign({}, optsArea));
                _onSubmit(Object.assign({}, optsArea));
                break;
        }
    });
    const renderList = () => {
        let datas = [];
        switch (state.cTab) {
            case 'prov':
                datas = state.provList;
                break;
            case 'city':
                datas = state.cityList;
                break;
            case 'area':
                datas = state.areaList;
                break;
        }
        return datas.map((v, k) => {
            var _a, _b, _c;
            let style = null;
            if ((state.cTab === 'prov' && v.id === ((_a = area === null || area === void 0 ? void 0 : area.prov) === null || _a === void 0 ? void 0 : _a.id)) || (state.cTab === 'city' && v.id === ((_b = area === null || area === void 0 ? void 0 : area.city) === null || _b === void 0 ? void 0 : _b.id)) || (state.cTab === 'area' && v.id === ((_c = area === null || area === void 0 ? void 0 : area.area) === null || _c === void 0 ? void 0 : _c.id))) {
                style = style_1.default.liActive;
            }
            return (react_1.default.createElement(Button_1.default, { styleContainer: style_1.default.li, key: `${state.cTab}_${v.id}`, onPress: () => {
                    onSelect(v, k);
                } },
                react_1.default.createElement(react_native_1.Text, { style: [style_1.default.liText, style] }, v.name),
                style && react_1.default.createElement(Icons_1.default, { type: "AntDesign", name: 'check', color: Colors_1.default.MainColor })));
        });
    };
    const renderTab = () => {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j;
        return (react_1.default.createElement(react_native_1.View, { style: style_1.default.tabs },
            react_1.default.createElement(Button_1.default, { styleContainer: [style_1.default.tab, state.cTab === 'prov' ? style_1.default.tabc : {}], onPress: () => {
                    onTab('prov');
                } },
                react_1.default.createElement(react_native_1.Text, { style: [style_1.default.tabText, state.cTab === 'prov' ? style_1.default.tabt : {}] }, ((_a = area === null || area === void 0 ? void 0 : area.prov) === null || _a === void 0 ? void 0 : _a.id) ? (_b = area === null || area === void 0 ? void 0 : area.prov) === null || _b === void 0 ? void 0 : _b.name : '请选择')),
            (types === 'city' || types === 'area') ? (react_1.default.createElement(Button_1.default, { styleContainer: [style_1.default.tab, state.cTab === 'city' ? style_1.default.tabc : {}], onPress: () => {
                    onTab('city');
                } }, ((_c = area === null || area === void 0 ? void 0 : area.city) === null || _c === void 0 ? void 0 : _c.id) ? (react_1.default.createElement(react_native_1.Text, { style: [style_1.default.tabText, state.cTab === 'city' ? style_1.default.tabt : {}] }, (_d = area === null || area === void 0 ? void 0 : area.city) === null || _d === void 0 ? void 0 : _d.name)) : (((_e = area === null || area === void 0 ? void 0 : area.prov) === null || _e === void 0 ? void 0 : _e.id) ? (react_1.default.createElement(react_native_1.Text, { style: [style_1.default.tabText, state.cTab === 'city' ? style_1.default.tabt : {}] }, "\u8BF7\u9009\u62E9")) : null))) : null,
            types === 'area' ? (react_1.default.createElement(Button_1.default, { styleContainer: [style_1.default.tab, state.cTab === 'area' ? style_1.default.tabc : {}], onPress: () => {
                    onTab('area');
                } }, ((_f = area === null || area === void 0 ? void 0 : area.area) === null || _f === void 0 ? void 0 : _f.id) ? (react_1.default.createElement(react_native_1.Text, { style: [style_1.default.tabText, state.cTab === 'area' ? style_1.default.tabt : {}] }, (_g = area === null || area === void 0 ? void 0 : area.area) === null || _g === void 0 ? void 0 : _g.name)) : (((_h = area === null || area === void 0 ? void 0 : area.prov) === null || _h === void 0 ? void 0 : _h.id) && ((_j = area === null || area === void 0 ? void 0 : area.city) === null || _j === void 0 ? void 0 : _j.id) ? (react_1.default.createElement(react_native_1.Text, { style: [style_1.default.tabText, state.cTab === 'area' ? style_1.default.tabt : {}] }, "\u8BF7\u9009\u62E9")) : null))) : null));
    };
    return (react_1.default.createElement(Drawer_1.default, { styleContainer: style_1.default.container, height: 500, cRef: refDrawer, title: title, scrollView: false, onClose: _onClose },
        renderTab(),
        react_1.default.createElement(react_native_1.ScrollView, { style: { paddingVertical: 10 } },
            renderList(),
            react_1.default.createElement(react_native_1.View, { style: { height: 40 } }))));
};
const CitySelect = (_a) => {
    var props = __rest(_a, []);
    citySelectView === null || citySelectView === void 0 ? void 0 : citySelectView.destroy();
    citySelectView = new react_native_root_siblings_1.default(react_1.default.createElement(CitySelectView, Object.assign({}, props)));
};
exports.default = CitySelect;
