"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_root_siblings_1 = __importDefault(require("react-native-root-siblings"));
const react_native_1 = require("react-native");
const style_1 = __importDefault(require("./style"));
const Button_1 = __importDefault(require("../Button"));
const Colors_1 = __importDefault(require("../Colors"));
let confirmView = undefined;
;
const ConfirmView = ({ scrollView = false, message, textAlign = 'center', title, btnCancel = '取消', onCancel, btnSubmit = '确定', onSubmit, }) => {
    const duration = 500;
    const fadeAnim = (0, react_1.useRef)(new react_native_1.Animated.Value(0)).current;
    const fadeScale = (0, react_1.useRef)(new react_native_1.Animated.Value(1)).current;
    const fadeOut = () => {
        react_native_1.Animated.timing(fadeAnim, {
            toValue: 0,
            duration,
            useNativeDriver: true
        }).start();
        react_native_1.Animated.timing(fadeScale, {
            toValue: 0,
            duration,
            useNativeDriver: true
        }).start();
    };
    const fadeIn = () => {
        react_native_1.Animated.timing(fadeAnim, {
            toValue: 1,
            duration,
            useNativeDriver: true
        }).start();
    };
    fadeIn();
    const _onCancel = () => {
        fadeOut();
        setTimeout(() => {
            confirmView === null || confirmView === void 0 ? void 0 : confirmView.destroy();
            onCancel === null || onCancel === void 0 ? void 0 : onCancel();
        }, duration);
    };
    const _onSubmit = () => {
        fadeOut();
        setTimeout(() => {
            confirmView === null || confirmView === void 0 ? void 0 : confirmView.destroy();
            onSubmit === null || onSubmit === void 0 ? void 0 : onSubmit();
        }, duration);
    };
    const renderMessage = () => {
        let style = {};
        let styleText = {};
        if (textAlign === 'center') {
            styleText = {
                textAlign: 'center'
            };
        }
        return (react_1.default.createElement(react_native_1.View, { style: [style_1.default.content, style] },
            react_1.default.createElement(react_native_1.Text, { style: [style_1.default.contentText, styleText] }, message)));
    };
    return (react_1.default.createElement(react_native_1.Animated.View, { style: [
            style_1.default.animate,
            { opacity: fadeAnim }
        ] },
        react_1.default.createElement(react_native_1.View, { style: style_1.default.container },
            react_1.default.createElement(react_native_1.Animated.View, { style: [
                    style_1.default.box,
                    { transform: [{ scale: fadeScale }] }
                ] },
                react_1.default.createElement(react_native_1.View, { style: style_1.default.boxTop }),
                react_1.default.createElement(react_native_1.View, { style: [style_1.default.boxMid, scrollView ? style_1.default.boxScroll : {}] },
                    title && (react_1.default.createElement(react_native_1.View, { style: style_1.default.title },
                        react_1.default.createElement(react_native_1.Text, { style: style_1.default.titleText }, title))),
                    scrollView ? (react_1.default.createElement(react_native_1.ScrollView, { style: style_1.default.scrollContent, alwaysBounceVertical: true, horizontal: false },
                        react_1.default.createElement(react_native_1.Text, { style: [style_1.default.scrollText] }, message))) : renderMessage(),
                    react_1.default.createElement(react_native_1.View, { style: style_1.default.buttonBox },
                        react_1.default.createElement(Button_1.default, { styleContainer: [
                                style_1.default.button,
                            ], styleText: [
                                style_1.default.buttonText,
                            ], text: btnCancel, onPress: _onCancel }),
                        react_1.default.createElement(react_native_1.View, { style: style_1.default.buttonBorder }),
                        react_1.default.createElement(Button_1.default, { styleContainer: [
                                style_1.default.button,
                            ], styleText: [
                                style_1.default.buttonText,
                                { color: Colors_1.default.MainColor }
                            ], text: btnSubmit, onPress: _onSubmit }))),
                react_1.default.createElement(react_native_1.View, { style: style_1.default.boxBottom })))));
};
const Confirm = (_a) => {
    var props = __rest(_a, []);
    confirmView === null || confirmView === void 0 ? void 0 : confirmView.destroy();
    confirmView = new react_native_root_siblings_1.default(react_1.default.createElement(ConfirmView, Object.assign({}, props)));
};
exports.default = Confirm;
