"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_native_1 = require("react-native");
const fontSize_1 = __importDefault(require("../Fn/fontSize"));
const static_1 = __importDefault(require("../Fn/static"));
const { width, height } = react_native_1.Dimensions.get('window');
const $alert = width - 50;
const styles = react_native_1.StyleSheet.create({
    animate: {
        position: 'absolute',
        left: 0,
        top: 0,
        width,
        height,
        zIndex: 99999,
    },
    container: {
        backgroundColor: 'rgba(0,0,0,.6)',
        flex: 1,
        flexDirection: 'column',
        justifyContent: 'center',
        alignItems: 'center',
    },
    box: {
        borderRadius: (0, fontSize_1.default)(10),
        flexDirection: 'column',
        justifyContent: 'center',
        alignItems: 'center',
    },
    boxScroll: {
        minHeight: (0, fontSize_1.default)(300),
        maxHeight: (0, fontSize_1.default)(600),
        width: $alert,
        overflow: 'hidden',
    },
    boxMid: {
        backgroundColor: '#fff',
        borderRadius: (0, fontSize_1.default)(static_1.default.radius),
        width: $alert,
    },
    boxTop: {
        flex: 1,
    },
    boxBottom: {
        flex: 1,
    },
    title: {
        alignItems: 'center',
        justifyContent: 'center',
        height: (0, fontSize_1.default)(60),
    },
    titleText: {
        fontSize: (0, fontSize_1.default)(20),
        fontWeight: '600',
        color: '#333',
        flexDirection: 'row',
        alignItems: 'center',
        justifyContent: 'center',
    },
    content: {
        padding: (0, fontSize_1.default)(20),
        paddingTop: 0,
    },
    contentText: {
        color: '#333',
        fontSize: (0, fontSize_1.default)(16),
        lineHeight: (0, fontSize_1.default)(20),
    },
    scrollContent: {
        padding: (0, fontSize_1.default)(20),
        paddingTop: 0,
    },
    scrollText: {
        color: '#333',
        fontSize: (0, fontSize_1.default)(16),
        lineHeight: (0, fontSize_1.default)(20),
    },
    buttonBox: {
        alignItems: 'center',
        flexDirection: 'row',
        borderTopColor: '#eee',
        borderTopWidth: 0.5,
    },
    button: {
        height: (0, fontSize_1.default)(60),
        alignItems: 'center',
        justifyContent: 'center',
        flex: 1,
    },
    buttonBorder: {
        borderRightColor: '#eee',
        borderRightWidth: 0.5,
        height: (0, fontSize_1.default)(30),
    },
    buttonText: {
        color: '#999',
        fontSize: (0, fontSize_1.default)(18),
        fontWeight: '600',
    }
});
exports.default = styles;
